
;
;
;-------------------------------
;
; scope_xt4 by Smack/Infect!
;
;-------------------------------
;
;use ASM-One to assemble this code
;enable CPU 68020 and FPU
;
;


	incdir	hd2:scope_xt4/src/

	include	os_macros.i
	include	hardware-registers.i



	section	code,code
;---DOSLIBRARY-----------------------------------
	move.l	(4).w,a6
	move.l	(378,a6),a0	;LibList
	lea	(dosname,pc),a1
	CALL	FindName
	move.l	d0,(dosbase)
	move.l	d0,a6
	move.l	#titletxt,d1
	CALL	PutStr
;---CPU FPU CHECK--------------------------------
	move.l	(4).w,a6
	btst	#4,(297,a6)	;ATTN_Flags(+1)  68881
	beq.b	.nofpu
	btst	#3,(297,a6)	;ATTN_Flags(+1)  68040
	beq.b	.fpuok
.nofpu
	move.l	#nofputxt,d1
	CALLDOS	PutStr
	subq	#1,(nofpu)
	bra.b	.go
.fpuok
	move.l	#fpuoktxt,d1
	CALLDOS	PutStr

.go	moveq	#77,d1
	CALL	Delay

	include	startup_nocheck.i	;jumps to 'main'
	include	dummysprites.i


;-------------------------------

dosname	dc.b	"dos.library",0
dosbase	dc.l	0
titletxt
	dc.b	27,"[1mSCOPE_XT4 by Smack/Infect! (Mon 19-Apr-99)",27,"[0m",10,0
nofputxt
	dc.b	"no FPU or 040/060 found -- dynamic gamma calculation disabled",10,0
fpuoktxt
	dc.b	"68881/882 FPU found -- dynamic gamma calculation enabled",10,0
	even




main
;---INIT COPPERLISTS-----------------------------
	lea	(cl1),a0
	bsr	dummysprites
	lea	(cl2),a0
	bsr	dummysprites
	lea	(cl3),a0
	bsr	dummysprites
	lea	(cl_help),a0
	bsr	dummysprites

	lea	(cl2pt+8+2),a0
	move.l	#spectrum_screen_full1,d0
	move	d0,(4,a0)
	swap	d0
	move	d0,(a0)

	lea	(cl3pt2+2),a0
	move.l	#spectrum_screen_tb1,d0
	move	d0,(4,a0)
	swap	d0
	move	d0,(a0)

	lea	(clpt_help+2),a0
	move.l	#help_screen,d0
	move	d0,(4,a0)
	swap	d0
	move	d0,(a0)

;---INIT AUDIO TIMING----------------------------
	lea	($dff000),a5
	move	#1,(aud0per,a5)
	move	#1,(aud1per,a5)
	move	#70/2,(aud2per,a5)	;period 70 = 50800
	move	#1,(aud2len,a5)		;(we want 1008*50 = 50400)
	move	#64,(aud0vol,a5)
	move	#64,(aud1vol,a5)
	move	#0,(aud2vol,a5)
	move	#0,(aud3vol,a5)

;---INIT PARALLEL PORT---------------------------
	lea	($bfd000),a1
	move.b	#6,($200,a1)		;DDRA SEL and POUT output
	move.b	#0,($1301,a1)		;DDRB PRB input
	move.b	#2,(a1)			;PRA  POUT signal
	or.b	#2,($1001,a1)		;FILTER OFF

;---INIT IRQ & DMA-------------------------------
	move.l	(smppt0,pc),a6
	move.l	(mainvbr,pc),a0
	move.l	($70,a0),(oldlevel4)
	move.l	#sample_interrupt_nosound,($70,a0)
	move.l	#frame_interrupt,($6c,a0)
	move.l	#key_interrupt,($68,a0)
	move	#$7fff,(adkcon,a5)
	move.l	#cl_help,(cop1lch,a5)
	move	#1,(copjmp1,a5)
	move	#$83a4,(dmacon,a5)	;bpl+cop+spr+aud2
	move	#$c228,(intena,a5)	;audio2+vblank+level2
	move	#0,(bplcon3,a5)



main_loop
	bsr.b	check_keyboard
	cmp.b	#$59,(keytaste)		** F10 down
	beq.b	.dont

;---DO THE REAL STUFF----------------------------
	bsr	swap_screen_buffers
	bsr	prepare_sample
	move	(plot_mode,pc),d0
	bne.b	.not_wave
	bsr	plot_wave
	bra.b	.dont
.not_wave
	bmi.b	.not_freq
	bsr	plot_freq
	bra.b	.dont
.not_freq
	bsr	plot_fft8

.dont	clr	(ready)
	cmp.b	#$58,(keytaste)		** F9 down
	bne.b	.ww0
.ww1	move	($dff006),($dff180)
	tst	(ready)
	beq.b	.ww1
	bra.b	main_loop
.ww0	tst	(ready)
	beq.b	.ww0

	cmp.b	#$c5,(keytaste)		** ESC up
	bne.b	main_loop


	move	#$7fff,($dff000+intena)
	move.l	(mainvbr,pc),a0
	move.l	(oldlevel4,pc),($70,a0)
	rts




*********************************************************
***** A6 register forbidden to use (sample pointer) *****
*********************************************************

;-------------------------------

check_keyboard
	move.b	(keytaste,pc),d0
	cmp.b	#$50,d0			** F1 down
	bne.b	.not_f1
	clr	(plot_mode)
	move.l	#cl1,($dff000+cop1lch)
	rts
.not_f1
	cmp.b	#$51,d0			** F2 down
	bne.b	.not_f2
	move	#1,(plot_mode)
	move.l	#cl2,($dff000+cop1lch)
	rts
.not_f2
	cmp.b	#$52,d0			** F3 down
	bne.b	.not_f3
	move	#-1,(plot_mode)
	move.l	#cl3,($dff000+cop1lch)
	bra	init_gray_palette
.not_f3
	cmp.b	#$55,d0			** F6 down
	bne.b	.not_f6
	move.l	(mainvbr,pc),a0
	move.l	#sample_interrupt,($70,a0)
	rts
.not_f6
	cmp.b	#$56,d0			** F7 down
	bne.b	.not_f7
	move.l	(mainvbr,pc),a0
	move.l	#sample_interrupt_nosound,($70,a0)
	rts
.not_f7
	cmp.b	#$5f,d0			** Help down
	bne.b	.not_help
	move.l	#cl_help,($dff000+cop1lch)
	rts
.not_help
	cmp.b	#1,d0			** 1 down
	bne.b	.not_1
	move	#1,(subsampling)
	move.l	#spectrum_screen_full1,d1
	move	d1,(cl2pt+10+4)
	swap	d1
	move	d1,(cl2pt+10)
	move.l	#spectrum_screen_tb1,d1
	move	d1,(cl3pt2+6)
	swap	d1
	move	d1,(cl3pt2+2)
	rts
.not_1
	cmp.b	#2,d0			** 2 down
	bne.b	.not_2
	move	#2,(subsampling)
	move.l	#spectrum_screen_full2,d1
	move	d1,(cl2pt+10+4)
	swap	d1
	move	d1,(cl2pt+10)
	move.l	#spectrum_screen_tb2,d1
	move	d1,(cl3pt2+6)
	swap	d1
	move	d1,(cl3pt2+2)
	rts
.not_2
	cmp.b	#3,d0			** 3 down
	bne.b	.not_3
	move	#3,(subsampling)
	move.l	#spectrum_screen_full3,d1
	move	d1,(cl2pt+10+4)
	swap	d1
	move	d1,(cl2pt+10)
	move.l	#spectrum_screen_tb3,d1
	move	d1,(cl3pt2+6)
	swap	d1
	move	d1,(cl3pt2+2)
	rts
.not_3
	rts






;-------------------------------

swap_screen_buffers
	lea	(wave_pt0,pc),a0	;double buf prev. frame
	movem.l	(a0)+,d0/d1
	exg	d0,d1
	movem.l	d0/d1,-(a0)
	lea	(cl1pt+2),a0
	lea	(cl2pt+2),a1
	move	d1,(4,a0)
	move	d1,(4,a1)
	swap	d1
	move	d1,(a0)
	move	d1,(a1)
	rts




;-------------------------------

prepare_sample
	move.l	(smppt0,pc),a0
	move.l	(fftpt0,pc),a2
	move	#$80,d2

	move	(subsampling,pc),d0
	cmp.b	#3,d0
	bne.b	.not_x4

;subsampling x 4
	move	#189-1,d7
.x4_1	clr	(a2)+
	dbf	d7,.x4_1
	move	#126-1,d7
.x4_2	move.b	(a0)+,d0	;1
	add.b	d2,d0
	ext	d0
	move.b	(a0)+,d1	;2
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;3
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;4
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;5
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;6
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;7
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;8
	add.b	d2,d1
	ext	d1
	add	d1,d0
	asr	#3,d0		;/8
	move	d0,(a2)+
	dbf	d7,.x4_2
	move	#189-1,d7
.x4_3	clr	(a2)+
	dbf	d7,.x4_3
	rts

.not_x4	cmp.b	#2,d0
	bne.b	.not_x2

;subsampling x 2
	moveq	#126-1,d7
.half1	clr	(a2)+
	dbf	d7,.half1
	move	#252-1,d7
.half2	move.b	(a0)+,d0	;1
	add.b	d2,d0
	ext	d0
	move.b	(a0)+,d1	;2
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;3
	add.b	d2,d1
	ext	d1
	add	d1,d0
	move.b	(a0)+,d1	;4
	add.b	d2,d1
	ext	d1
	add	d1,d0
	asr	#2,d0		;/4
	move	d0,(a2)+
	dbf	d7,.half2
	moveq	#126-1,d7
.half3	clr	(a2)+
	dbf	d7,.half3
	rts

.not_x2

;full frequency
	move	#504-1,d7
.full	move.b	(a0)+,d0	;1
	add.b	d2,d0
	ext	d0
	move.b	(a0)+,d1	;2
	add.b	d2,d1
	ext	d1
	add	d1,d0
	asr	#1,d0		;/2
	move	d0,(a2)+
	dbf	d7,.full
	rts




;-------------------------------

plot_wave
	lea	(fastscr+129*64),a5	;clear fast ram image
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	sub.l	a0,a0
	sub.l	a1,a1
	sub.l	a2,a2
	sub.l	a3,a3
	sub.l	a4,a4
	moveq	#129/3-1,d0	;43 loops
.clloop	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	dbf	d0,.clloop	;48*4=192 bytes = 3 rows (64 bytes)

	move.l	(fftpt0,pc),a0		;plot to fast ram image
	lea	(fastscr+64*64),a2
	move	(a0),d1
	neg	d1
	asr	#1,d1
	moveq	#63-1,d7
.ploop0	moveq	#-$80,d5
.ploop1	move	(a0)+,d0
	moveq	#64,d4
	neg	d0
	asr	#1,d0
	move	d0,d6
	lsl	#6,d6
	sub	d0,d1
	beq.b	.ploop2
	subq	#1,d1
	bge.b	.ploop2
	not	d1
	neg	d4
	subq	#1,d1
.ploop2	or.b	d5,(a2,d6)
	add	d4,d6
	dbf	d1,.ploop2
	move	d0,d1
	lsr.b	#1,d5
	bne.b	.ploop1
	addq.l	#1,a2
	dbf	d7,.ploop0

	lea	(fastscr),a4		;copy to video ram
	move.l	(wave_pt0,pc),a5
	move	#129-1,d0
.coloop	REPT	16
	move.l	(a4)+,(a5)+
	ENDR
	dbf	d0,.coloop
	rts



;-------------------------------

plot_freq
	lea	(fastscr+129*32),a5	;clear fast ram image
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	sub.l	a0,a0
	sub.l	a1,a1
	sub.l	a2,a2
	sub.l	a3,a3
	sub.l	a4,a4
	moveq	#129/3-1,d0	;43 loops
.clloop	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	movem.l	d1-a4,-(a5)	;12*4=48 bytes
	dbf	d0,.clloop	;48*2=96 bytes = 3 rows (32 bytes)

	move.l	(fftpt0,pc),a0
	bsr	deli_fft

	lea	(fastscr+128*32),a1
	move.l	(fftpt0,pc),a0
	lea	(fftbuf1),a2
	lea	(fft_peak,pc),a3
	addq.l	#2,a0
	moveq	#9,d4
	moveq	#32,d5
	moveq	#$40,d6
	move	#250-1,d7	;250
.plot_loop
	moveq	#0,d0
	moveq	#0,d1
	move	(a0)+,d0
	lsr	d4,d0		;#9
	move	(a2),d1
	move	(2,a2),d2
	cmp	d0,d1
	bgt.b	.peak_greater
	move	d0,(a2)+
	clr	(a2)+
	bra.b	.peak_new
.peak_greater
	lsl	#5,d1
	neg.l	d1
	or.b	d6,(a1,d1.l)
	move	(a3,d2*2),d1
	sub	d1,(a2)+
	addq	#1,(a2)+	
.peak_new
	lsl	#5,d0
	neg.l	d0
.plot_bar
	or.b	d6,(a1,d0.l)
	add.l	d5,d0
	ble.b	.plot_bar
	lsr.b	#1,d6
	bne.b	.bitok
	moveq	#-$80,d6
	addq.l	#1,a1
.bitok	dbf	d7,.plot_loop

	lea	(fastscr),a4		;copy to video ram
	move.l	(wave_pt0,pc),a5
	move	#129-1,d0
.coloop	REPT	8
	move.l	(a4)+,(a5)+
	ENDR
	dbf	d0,.coloop
	rts





;-------------------------------

init_gray_palette
	lea	(gamma,pc),a0
	move.l	a0,a1
	move	(nofpu,pc),d0
	bne.b	.no_fpu
	move	#255,d6
	moveq	#0,d1
	fmove.b	#1,fp2
	fmove.s	(gamma_value,pc),fp4
	fdiv	fp4,fp2		;1/gamma
	move	d6,d7
.loop	fmove.w	d1,fp0
	fdiv.w	d6,fp0
	flogn	fp0
	fmul	fp2,fp0
	fetox	fp0		;x^gamma = e^(ln(x)*gamma)
	fmul.w	d6,fp0
	fint	fp0
	fmove.w	fp0,d0
	cmp	d6,d0
	ble.b	.ok
	move	d6,d0
.ok	move.b	d0,(a1)+
	addq	#1,d1
	dbf	d7,.loop
.no_fpu
	lea	($dff000+bplcon3),a2
	move	#$2000,d5	;color bank +1
	move	#$0c00,d4	;color hi
	move	#$0e00,d3	;color lo
	moveq	#7,d7		;8 color banks
.loop0	lea	($dff000+color00),a1
	moveq	#31,d6		;32 entries per bank
.loop1	move.b	(a0)+,d0
	move.b	d0,d1
	lsr.b	#4,d0
	move.b	d0,d2
	lsl	#4,d0
	or.b	d2,d0
	lsl	#4,d0
	or.b	d2,d0
	move	d4,(a2)
	move	d0,(a1)		;color hi
	and.b	#$0f,d1
	move.b	d1,d2
	lsl	#4,d1
	or.b	d2,d1
	lsl	#4,d1
	or.b	d2,d1
	move	d3,(a2)
	move	d1,(a1)+	;color lo
	dbf	d6,.loop1
	add	d5,d4
	add	d5,d3
	dbf	d7,.loop0
	move	#0,(a2)
	rts
gamma_value	dc.s	1.6






;-------------------------------

plot_fft8
	move	(nofpu,pc),d0
	bne.w	.no_fpu
	lea	(gamma_value,pc),a0
	fmove.s	(a0),fp0
	lea	(keytaste,pc),a1
	move.b	(a1),d0

	cmp.b	#$4c,d0			** Cursor_Up down
	bne.b	.not_up
	clr.b	(a1)
	fadd.s	#0.05,fp0
	fmove.s	fp0,(a0)
	bsr	init_gray_palette
	bra.b	.behind_keys
.not_up
	cmp.b	#$4d,d0			** Cursor_Down down
	bne.b	.not_down
	clr.b	(a1)
	fsub.s	#0.05,fp0
	fcmp.b	#1,fp0
	fbge	.downok
	fmove.b	#1,fp0
.downok	fmove.s	fp0,(a0)
	bsr	init_gray_palette
	bra.b	.behind_keys
.not_down
	cmp.b	#$4e,d0			** Cursor_Right down
	bne.b	.not_right
	clr.b	(a1)
	fadd.s	#0.2,fp0
	fmove.s	fp0,(a0)
	bsr	init_gray_palette
	bra.b	.behind_keys
.not_right
	cmp.b	#$4f,d0			** Cursor_Left down
	bne.b	.not_left
	clr.b	(a1)
	fsub.s	#0.2,fp0
	fcmp.b	#1,fp0
	fbge	.leftok
	fmove.b	#1,fp0
.leftok	fmove.s	fp0,(a0)
	bsr	init_gray_palette
.not_left
.behind_keys
.no_fpu

	move.l	(fftpt0,pc),a0
	bsr	deli_fft

	move.l	(fftpt0,pc),a0
	move.l	a0,a1
	addq.l	#2,a0
	clr.b	(a1)+
	move	#250-1,d1
.prepare_loop
	move	(a0)+,d0
	lsr	#8,d0
	addq.b	#1,d0
	bne.b	.prepare_ok
	moveq	#-1,d0
.prepare_ok
	move.b	d0,(a1)+
	dbf	d1,.prepare_loop
	clr.b	(a1)+
	clr.l	(a1)+

	move.l	(fftpt0,pc),a0
	move.l	(.scr_pt,pc),a1
	bsr.b	c2p

	move.l	(fftpt0,pc),a0
	move.l	(.scr_pt,pc),a1
	add	#256/8*240,a1
	bsr.b	c2p

	lea	(cl3pt+2),a0
	move.l	(.scr_pt,pc),d0
	moveq	#7,d1
.clloop	move	d0,(4,a0)
	swap	d0
	move	d0,(a0)
	addq.l	#8,a0
	swap	d0
	add.l	#bplsize,d0
	dbf	d1,.clloop

	move.l	(.scr_pt,pc),d0
	sub.l	#256/8,d0
	move.l	(.scr8pt,pc),d1
	cmp.l	d1,d0
	bge.b	.pt_ok
	move.l	(.scr8pt,pc),d0
	add.l	#256/8*239,d0
.pt_ok	lea	(.scr_pt,pc),a0
	move.l	d0,(a0)
	rts

.scr8pt	dc.l	scr8
.scr_pt	dc.l	scr8+10*256/8




;-------------------------------

;**** chunky2planar routine
;****
;**** a0 - chunky input,  a1 - planar output
;**** 256 input pixels are converted (one row on the screen)
;**** bitplane size: 256*480 pixels (256*240 visible)
bplsize = 256/8*480

c2p	movem.l	a0/a1,-(a7)	;push input/output pointers
	move.l	#$33333333,d5
	move.l	#$55555555,d6
	lea	(256,a0),a2	;chunky input end
	lea	(2*bplsize,a1),a1	;bitplane 2
;loop 1 - bitplanes 0,1,2,3
	move.l	(a0)+,d0
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	#$0f0f0f0f,d4
	and.l	d4,d0
	and.l	d4,d2
	lsl.l	#4,d0
	or.l	d2,d0
	and.l	d4,d1
	and.l	d4,d3
	lsl.l	#4,d1
	or.l	d3,d1
	move.l	d1,a3
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	(a0)+,d7
	and.l	d4,d1
	and.l	d4,d2
	lsl.l	#4,d2
	or.l	d1,d2
	and.l	d4,d3
	and.l	d4,d7
	lsl.l	#4,d3
	or.l	d7,d3
	move.l	a3,d1
	swap	d2
	move	d0,d7
	move	d2,d0
	move	d7,d2
	swap	d2
	swap	d3
	move	d1,d7
	move	d3,d1
	move	d7,d3
	swap	d3
	bra.b	.entry1
.loop1	move.l	(a0)+,d0
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	d7,(a1)+	;bitplane 2
	move.l	#$f0f0f0f,d4
	and.l	d4,d0
	and.l	d4,d2
	lsl.l	#4,d0
	or.l	d2,d0
	and.l	d4,d1
	and.l	d4,d3
	lsl.l	#4,d1
	or.l	d3,d1
	move.l	d1,a3
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	(a0)+,d7
	move.l	a4,(-bplsize-4,a1)	;bitplane 1
	and.l	d4,d1
	and.l	d4,d2
	lsl.l	#4,d2
	or.l	d1,d2
	and.l	d4,d3
	and.l	d4,d7
	lsl.l	#4,d3
	or.l	d7,d3
	move.l	a3,d1
	swap	d2
	move	d0,d7
	move	d2,d0
	move	d7,d2
	swap	d2
	swap	d3
	move	d1,d7
	move	d3,d1
	move	d7,d3
	swap	d3
	move.l	a5,(-bplsize*2-4,a1)	;bitplane 0
.entry1	move.l	#$00ff00ff,d4
	move.l	d2,d7
	lsr.l	#2,d7
	eor.l	d0,d7
	and.l	d5,d7
	eor.l	d7,d0
	lsl.l	#2,d7
	eor.l	d7,d2
	move.l	d3,d7
	lsr.l	#2,d7
	eor.l	d1,d7
	and.l	d5,d7
	eor.l	d7,d1
	lsl.l	#2,d7
	eor.l	d7,d3
	move.l	d1,d7
	lsr.l	#8,d7
	eor.l	d0,d7
	and.l	d4,d7
	eor.l	d7,d0
	lsl.l	#8,d7
	eor.l	d7,d1
	move.l	d1,d7
	lsr.l	#1,d7
	eor.l	d0,d7
	and.l	d6,d7
	eor.l	d7,d0
	move.l	d0,(bplsize,a1)	;bitplane 3
	add.l	d7,d7
	eor.l	d1,d7
	move.l	d3,d1
	lsr.l	#8,d1
	eor.l	d2,d1
	and.l	d4,d1
	eor.l	d1,d2
	lsl.l	#8,d1
	eor.l	d1,d3
	move.l	d3,d1
	lsr.l	#1,d1
	eor.l	d2,d1
	and.l	d6,d1
	eor.l	d1,d2
	add.l	d1,d1
	eor.l	d1,d3
	move.l	d2,a4
	move.l	d3,a5
	cmp.l	a0,a2
	bgt	.loop1
	move.l	d7,(a1)		;bitplane 2
	move.l	a4,(-bplsize,a1)	;bitplane 1
	move.l	a5,(-bplsize*2,a1)	;bitplane 0

	movem.l	(a7)+,a0/a1	;pop input/output pointers
	add.l	#bplsize*6,a1	;pointer to bitplane 6
;loop 2 - bitplanes 4,5,6,7
	move.l	(a0)+,d0
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	#$f0f0f0f0,d4
	and.l	d4,d0
	and.l	d4,d2
	lsr.l	#4,d2
	or.l	d2,d0
	and.l	d4,d1
	and.l	d4,d3
	lsr.l	#4,d3
	or.l	d3,d1
	move.l	d1,a3
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	(a0)+,d7
	and.l	d4,d1
	and.l	d4,d2
	lsr.l	#4,d1
	or.l	d1,d2
	and.l	d4,d3
	and.l	d4,d7
	lsr.l	#4,d7
	or.l	d7,d3
	move.l	a3,d1
	swap	d2
	move	d0,d7
	move	d2,d0
	move	d7,d2
	swap	d2
	swap	d3
	move	d1,d7
	move	d3,d1
	move	d7,d3
	swap	d3
	bra.b	.entry2
.loop2	move.l	(a0)+,d0
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	d7,(a1)+	;bitplane 6
	move.l	#$f0f0f0f0,d4
	and.l	d4,d0
	and.l	d4,d2
	lsr.l	#4,d2
	or.l	d2,d0
	and.l	d4,d1
	and.l	d4,d3
	lsr.l	#4,d3
	or.l	d3,d1
	move.l	d1,a3
	move.l	(a0)+,d2
	move.l	(a0)+,d1
	move.l	(a0)+,d3
	move.l	(a0)+,d7
	move.l	a4,(-bplsize-4,a1)	;bitplane 5
	and.l	d4,d1
	and.l	d4,d2
	lsr.l	#4,d1
	or.l	d1,d2
	and.l	d4,d3
	and.l	d4,d7
	lsr.l	#4,d7
	or.l	d7,d3
	move.l	a3,d1
	swap	d2
	move	d0,d7
	move	d2,d0
	move	d7,d2
	swap	d2
	swap	d3
	move	d1,d7
	move	d3,d1
	move	d7,d3
	swap	d3
	move.l	a5,(-bplsize*2-4,a1)	;bitplane 4
.entry2	move.l	#$00ff00ff,d4
	move.l	d2,d7
	lsr.l	#2,d7
	eor.l	d0,d7
	and.l	d5,d7
	eor.l	d7,d0
	lsl.l	#2,d7
	eor.l	d7,d2
	move.l	d3,d7
	lsr.l	#2,d7
	eor.l	d1,d7
	and.l	d5,d7
	eor.l	d7,d1
	lsl.l	#2,d7
	eor.l	d7,d3
	move.l	d1,d7
	lsr.l	#8,d7
	eor.l	d0,d7
	and.l	d4,d7
	eor.l	d7,d0
	lsl.l	#8,d7
	eor.l	d7,d1
	move.l	d1,d7
	lsr.l	#1,d7
	eor.l	d0,d7
	and.l	d6,d7
	eor.l	d7,d0
	move.l	d0,(bplsize,a1)	;bitplane 7
	add.l	d7,d7
	eor.l	d1,d7
	move.l	d3,d1
	lsr.l	#8,d1
	eor.l	d2,d1
	and.l	d4,d1
	eor.l	d1,d2
	lsl.l	#8,d1
	eor.l	d1,d3
	move.l	d3,d1
	lsr.l	#1,d1
	eor.l	d2,d1
	and.l	d6,d1
	eor.l	d1,d2
	add.l	d1,d1
	eor.l	d1,d3
	move.l	d2,a4
	move.l	d3,a5
	cmp.l	a0,a2
	bgt	.loop2
	move.l	d7,(a1)		;bitplane 6
	move.l	a4,(-bplsize,a1)	;bitplane 5
	move.l	a5,(-bplsize*2,a1)	;bitplane 4
	rts




;-------------------------------

sample_interrupt
	move.l	d0,-(a7)
	move	#$0780,($dff000+intreq)
	moveq	#0,d0
	move.b	($bfe101),d0		*PRB CIA-A
	move.b	d0,(a6)+
	move	(playback_lookup,pc,d0.l*2),d0
	move	d0,($dff000+aud0dat)
	move	d0,($dff000+aud1dat)
	move	d0,($dff000+aud2dat)
	move.l	(a7)+,d0
	rte
sample_interrupt_nosound
	move	#$0780,($dff000+intreq)
	move.b	($bfe101),(a6)+		*PRB CIA-A
	move	d0,($dff000+aud2dat)
	rte
playback_lookup
i	set	$80
	REPT	256
	dc.b	i,i
i	set	(i+1)&$ff
	ENDR




;-------------------------------

frame_interrupt
	movem.l	d0/d1/a0,-(a7)
	move	#$0020,($dff000+intreq)
	st	(ready)
	lea	(smppt0,pc),a0
	movem.l	(a0)+,d0/d1
	exg	d0,d1
	movem.l	d0/d1,-(a0)
	move.l	d1,a6
	movem.l	(a7)+,d0/d1/a0
	rte



;-------------------------------

key_interrupt
	movem.l	d0-d2,-(a7)
	btst	#3,($bfed01)	*ICR
	beq.b	.nokey
	move.b	($bfec01),d0	**get key
	not.b	d0
	ror.b	#1,d0
	move.b	d0,(keytaste)
	moveq	#3,d2
.rwait0	move.b	($dff006),d0
.rwait1	move.b	($dff006),d1
	cmp.b	d0,d1
	beq.b	.rwait1
	dbf	d2,.rwait0
	bset	#6,($bfee01)	**INMODE
	move.b	#0,($bfec01)	**Handshake
	bclr	#6,($bfee01)	**OUTMODE
.nokey	nop
	move	#8,($dff000+intreq)
	movem.l	(a7)+,d0-d2
	rte


;-------------------------------

plot_mode	dc	0
oldlevel4	dc.l	0
wave_pt0	dc.l	scr0
wave_pt1	dc.l	scr1
ready		dc	0
smppt0		dc.l	smpbuf0
smppt1		dc.l	smpbuf1
fftpt0		dc.l	fftbuf0
keytaste	dc.b	0,0
nofpu		dc	0
subsampling	dc	1

fft_peak
	dc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc	1,1,1,1,1,1,1,1,1
	dc	2,2,2,2,2,2,2,2,2
	dc	3,3,3,3,3,3
	dc	4,4,4,4
	dc	5,5,5
	dc	6,6,6
	dc	7,7,7
	dc	8,8,8
	dc	9,9,9,9,9,9,9,9

gamma	include	gamma_1.6.i


;-------------------------------

	include	deli_fft.i




*******************************************************
	section	buff,bss

	ds.b	1024
fastscr	ds.b	128*129
	ds.b	1024
smpbuf0	ds.b	1024*4
smpbuf1	ds.b	1024*4
fftbuf0	ds.b	1024*2
fftbuf1	ds.b	1024*2


*******************************************************
	section	screen,bss_c

	ds.b	1024
scr0	ds.b	92*129
scr1	ds.b	92*129
	ds.b	1024
scr8	ds.b	256*480
	ds.b	1024


*******************************************************
	section	chip,data_c

spectrum_screen_full1
	incbin	bin/spectrum_screen_full.raw
spectrum_screen_full2 = spectrum_screen_full1+1*256/8*129
spectrum_screen_full3 = spectrum_screen_full1+2*256/8*129

spectrum_screen_tb1
	incbin	bin/spectrum_screen_topbottom.raw
spectrum_screen_tb2 = spectrum_screen_tb1+1*256/8*22
spectrum_screen_tb3 = spectrum_screen_tb1+2*256/8*22

help_screen
	incbin	bin/help_screen.raw

dummy_sprite	dc.l	0,0,0,0



backcol	set	$0131



;-------------------------------

;**** oscilloscope
cl1	ds	32
	dc	(15<<8)+5,-2
	dc	bpl1mod,0,bpl2mod,0,bplcon1,0
	dc	diwstrt,$1a6a,diwstop,$3ae0
	dc	ddfstrt,$4c,ddfstop,$4c+(512-32)/4
	dc	fmode,0
	dc	color00,$0000,color01,$0cf8
cl1pt	dc	bpl0pth,0,bpl0ptl,0
	dc	(100<<8)+5,-2,bplcon0,$9000,color00,backcol
	dc	((100+64)<<8)+9,-2,color00,backcol+$0121
	dc	((100+65)<<8)+9,-2,color00,backcol
	dc	((100+129)<<8)+5,-2,bplcon0,0,color00,$0000
	dc	-1,-2


;-------------------------------

;**** spectrum analyzer
cl2	ds	32
	dc	(15<<8)+5,-2
	dc	bpl1mod,0,bpl2mod,0,bplcon1,0
	dc	diwstrt,$1a6a,diwstop,$3ae0
	dc	ddfstrt,$48,ddfstop,$48+(256-16)/2
	dc	fmode,0
	dc	color00,$0000,color01,$0cf8
	dc	color02,backcol+$0222,color03,$0cf8-$0222
cl2pt	dc	bpl0pth,0,bpl0ptl,0
	dc	bpl1pth,0,bpl1ptl,0
	dc	(100<<8)+5,-2,bplcon0,$2000,color00,backcol
	dc	((100+129)<<8)+5,-2,bplcon0,0,color00,$0000
	dc	-1,-2


;-------------------------------

water_top 	set 48
;**** waterfall plot
cl3	ds	32
	dc	(15<<8)+5,-2
	dc	color00,backcol
	dc	bpl1mod,0,bpl2mod,0,bplcon1,$8800
	dc	diwstrt,$1a6a,diwstop,$3ae0
	dc	ddfstrt,$3c,ddfstop,$3c+(256-64)/2
	dc	fmode,3
	dc	((water_top-15)<<8)+5,-2,bplcon0,$1000
	dc	((water_top-1)<<8)+$cd,-2,bplcon0,$0010
	dc	color01,0
cl3pt	dc	bpl0pth,0,bpl0ptl,0
	dc	bpl1pth,0,bpl1ptl,0
	dc	bpl2pth,0,bpl2ptl,0
	dc	bpl3pth,0,bpl3ptl,0
	dc	bpl4pth,0,bpl4ptl,0
	dc	bpl5pth,0,bpl5ptl,0
	dc	bpl6pth,0,bpl6ptl,0
	dc	bpl7pth,0,bpl7ptl,0
	dc	$ffe1,-2
	dc	((water_top-256+239)<<8)+5,-2,bplcon0,$1000
	dc	color01,backcol+$0222
cl3pt2	dc	bpl0pth,0,bpl0ptl,0
	dc	((water_top+7-256+239)<<8)+5,-2,bplcon0,0
	dc	-1,-2


;-------------------------------

;**** help page
cl_help	ds	32
	dc	(15<<8)+5,-2
	dc	bpl1mod,0,bpl2mod,0,bplcon1,0
	dc	diwstrt,$1a6a,diwstop,$3ae0
	dc	ddfstrt,$38,ddfstop,$38+(320-16)/2
	dc	fmode,0
	dc	color00,$0118,color01,$0ddd
clpt_help
	dc	bpl0pth,0,bpl0ptl,0
	dc	(40<<8)+5,-2,bplcon0,$1000
	dc	$ffe1,-2
	dc	(40<<8)+5,-2,bplcon0,0
	dc	-1,-2

